com.trendmicro.ds.appcontrol.rest.api

## Interface IDriftAPI

-     @Produces(value="application/json")
       @Consumes(value="application/json")
       @Path(value="software-inventory/drift")
      public interface IDriftAPI

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `DescribeApplicationResponse` | `describeApplication(java.lang.String sessionID, java.lang.String sha256, DescribeApplicationRequest request)` Gets details about a given executable, identified by sha256, using inventory change data within the provided search scope.
    `DescribeApplicationDriftResponse` | `describeApplicationDrift(java.lang.String sessionID, java.lang.String sha256, DescribeApplicationDriftRequest request)` Gets a list of the instances of the given unreviewed application, identified by SHA256, within the provided search scope.
    `DescribeComputerDriftResponse` | `describeComputerDrift(java.lang.String sessionID, int hostID, DescribeComputerDriftRequest request)` Gets a list of all unreviewed drift items within the provided search scope.
    `DescribeDriftResponse` | `describeDrift(java.lang.String sessionID, DescribeDriftRequest request)` Gets metadata describing the drift that has occurred within the provided search scope.
    `DescribeDriftDetailsResponse` | `describeDriftDetails(java.lang.String sessionID, long changeID)` Gets computer and file details for the provided inventory change.
    `ListApplicationDriftResponse` | `listApplicationDrift(java.lang.String sessionID, ListApplicationDriftRequest request)` Gets the list of unreviewed applications, grouped by SHA256, within the provided search scope.
    `ListComputerDriftResponse` | `listComputerDrift(java.lang.String sessionID, ListComputerDriftRequest request)` Gets the list of hosts that have had unreviewed drift items within the provided search scope.
    `ListHostGroupsResponse` | `listHostGroups(java.lang.String sessionID, ListHostGroupsRequest request)` Gets the tree of all host groups with hosts that have had unreviewed inventory changes within the provided search scope.
    `ReviewApplicationDriftResponse` | `reviewApplicationDrift(java.lang.String sessionID, java.lang.String sha256, ReviewApplicationDriftRequest request)` Performs an allow or block action on all instances of the given application, identified by SHA256, within the provided search scope scope.
    `ReviewComputerDriftResponse` | `reviewComputerDrift(java.lang.String sessionID, int hostID, ReviewComputerDriftRequest request)` Performs an allow or block action on all drift items on the given host ID within the provided search scope.
    `ReviewDriftItemResponse` | `reviewDriftItem(java.lang.String sessionID, long changeID, ReviewDriftItemRequest request)` Performs an allow or block action on one inventory change.

- - ### Method Detail

    - #### describeDrift

          @POST
           @Path(value="histogram")
          DescribeDriftResponse describeDrift(@CookieParam(value="sID")
                                                                              java.lang.String sessionID,
                                                                              DescribeDriftRequest request)
                                                                       throws java.lang.Exception

      Gets metadata describing the drift that has occurred within the provided search scope.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `request` - a `DescribeDriftRequest` specifying the search scope.
      Returns:
        a `DescribeDriftResponse` with drift metadata counts by hour bucket bounded by the search scope.
      Throws:
        `java.lang.Exception`

    - #### listHostGroups

          @POST
           @Path(value="host-groups")
          ListHostGroupsResponse listHostGroups(@CookieParam(value="sID")
                                                                                  java.lang.String sessionID,
                                                                                  ListHostGroupsRequest request)
                                                                           throws java.lang.Exception

      Gets the tree of all host groups with hosts that have had unreviewed inventory changes within the provided search scope.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `request` - a `ListHostGroupsRequest` specifying the search scope.
      Returns:
        a `ListHostGroupsResponse` containing the tree of all host groups with hosts that have had unreviewed inventory changes within the provided search scope.
      Throws:
        `java.lang.Exception`

    - #### listApplicationDrift

          @POST
           @Path(value="applications")
          ListApplicationDriftResponse listApplicationDrift(@CookieParam(value="sID")
                                                                                               java.lang.String sessionID,
                                                                                               ListApplicationDriftRequest request)
                                                                                        throws java.lang.Exception

      Gets the list of unreviewed applications, grouped by SHA256, within the provided search scope.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `scope` - a valid scope object, with optional host group ID
      Returns:
        a `ListApplicationDriftResponse` object containing the list of unreviewed applications, grouped by SHA256, within the provided search scope.
      Throws:
        `java.lang.Exception`

    - #### listComputerDrift

          @POST
           @Path(value="computers")
          ListComputerDriftResponse listComputerDrift(@CookieParam(value="sID")
                                                                                      java.lang.String sessionID,
                                                                                      ListComputerDriftRequest request)
                                                                               throws java.lang.Exception

      Gets the list of hosts that have had unreviewed drift items within the provided search scope.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `request` - a `ListComputerDriftRequest` specifying the search scope.
      Returns:
        a `ListComputerDriftResponse` object containing the list of hosts that have had unreviewed drift items within the provided search scope.
      Throws:
        `java.lang.Exception`

    - #### describeApplication

          @POST
           @Path(value="applications/{sha256}/details")
          DescribeApplicationResponse describeApplication(@CookieParam(value="sID")
                                                                                                              java.lang.String sessionID,
                                                                                                              @PathParam(value="sha256")
                                                                                                              java.lang.String sha256,
                                                                                                              DescribeApplicationRequest request)
                                                                                                       throws java.lang.Exception

      Gets details about a given executable, identified by sha256, using inventory change data within the provided search scope.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `request` - a `DescribeApplicationRequest` specifying the search scope.
      Returns:
        a `DescribeApplicationResponse` object containing details about a given executable, identified by sha256, using inventory change data within the given scope.
      Throws:
        `java.lang.Exception`

    - #### describeApplicationDrift

          @POST
           @Path(value="applications/{sha256}/occurrences")
          DescribeApplicationDriftResponse describeApplicationDrift(@CookieParam(value="sID")
                                                                                                                            java.lang.String sessionID,
                                                                                                                            @PathParam(value="sha256")
                                                                                                                            java.lang.String sha256,
                                                                                                                            DescribeApplicationDriftRequest request)
                                                                                                                     throws java.lang.Exception

      Gets a list of the instances of the given unreviewed application, identified by SHA256, within the provided search scope.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `sha256` - the application sha256
        `request` - a `DescribeApplicationDriftRequest` specifying the search scope.
      Returns:
        a `DescribeApplicationDriftResponse` object containing a list of the instances of the given unreviewed application, identified by SHA256, within the provided search scope.
      Throws:
        `java.lang.Exception`

    - #### reviewApplicationDrift

          @POST
           @Path(value="applications/{sha256}/action")
          ReviewApplicationDriftResponse reviewApplicationDrift(@CookieParam(value="sID")
                                                                                                                   java.lang.String sessionID,
                                                                                                                   @PathParam(value="sha256")
                                                                                                                   java.lang.String sha256,
                                                                                                                   ReviewApplicationDriftRequest request)
                                                                                                            throws java.lang.Exception

      Performs an allow or block action on all instances of the given application, identified by SHA256, within the provided search scope scope.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `sha256` - the application sha256
        `request` - a `ReviewApplicationDriftRequest` specifying the search scope.
      Throws:
        `java.lang.Exception`

    - #### describeComputerDrift

          @POST
           @Path(value="computers/{hostID}/occurrences")
          DescribeComputerDriftResponse describeComputerDrift(@CookieParam(value="sID")
                                                                                                                   java.lang.String sessionID,
                                                                                                                   @PathParam(value="hostID")
                                                                                                                   int hostID,
                                                                                                                   DescribeComputerDriftRequest request)
                                                                                                            throws java.lang.Exception

      Gets a list of all unreviewed drift items within the provided search scope.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `hostID` - the host ID
        `request` - a `DescribeComputerDriftRequest` specifying the search scope.
      Returns:
        a `DescribeComputerDriftResponse` object containing a list of all unreviewed drift items within the provided search scope.
      Throws:
        `java.lang.Exception`

    - #### reviewComputerDrift

          @POST
           @Path(value="computers/{hostID}/action")
          ReviewComputerDriftResponse reviewComputerDrift(@CookieParam(value="sID")
                                                                                                          java.lang.String sessionID,
                                                                                                          @PathParam(value="hostID")
                                                                                                          int hostID,
                                                                                                          ReviewComputerDriftRequest request)
                                                                                                   throws java.lang.Exception

      Performs an allow or block action on all drift items on the given host ID within the provided search scope.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `hostID` - the host ID
        `request` - a `ReviewComputerDriftRequest` specifying the search scope.
      Throws:
        `java.lang.Exception`

    - #### describeDriftDetails

          @GET
           @Path(value="occurrences/{changeID}")
          DescribeDriftDetailsResponse describeDriftDetails(@CookieParam(value="sID")
                                                                                                        java.lang.String sessionID,
                                                                                                        @PathParam(value="changeID")
                                                                                                        long changeID)
                                                                                                 throws java.lang.Exception

      Gets computer and file details for the provided inventory change.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `changeID` - the change ID
      Returns:
        a summary of file and computer details for the given change ID.
      Throws:
        `java.lang.Exception`

    - #### reviewDriftItem

          @POST
           @Path(value="occurrences/{changeID}/action")
          ReviewDriftItemResponse reviewDriftItem(@CookieParam(value="sID")
                                                                                                      java.lang.String sessionID,
                                                                                                      @PathParam(value="changeID")
                                                                                                      long changeID,
                                                                                                      ReviewDriftItemRequest request)
                                                                                               throws java.lang.Exception

      Performs an allow or block action on one inventory change.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API.
        `changeID` - the change ID
        `request` - a `ReviewComputerDriftRequest` specifying the action to take when the application identified in the drift item is launched.
      Throws:
        `java.lang.Exception`

Copyright © 2017 Trend Micro Inc. All Rights Reserved.